VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   0  'None
   Caption         =   "DD Animation"
   ClientHeight    =   5625
   ClientLeft      =   2355
   ClientTop       =   1620
   ClientWidth     =   7065
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   375
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   471
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit 'DirectX likes all it's variables to be predefined

Dim binit As Boolean 'A simple flag (true/false) that states whether we've
'initialised or not. If the initialisation is successful this changes to
'true, the program also checks before doing any drawing if this flag is
'true. If the initialisation failed and we try and draw things we'll get
'lots of errors...

Dim dx As New DirectX7 'This is the root object. DirectDraw is created From this
Dim dd As DirectDraw7 'This is DirectDraw, all things DirectDraw come From here
Dim Mainsurf As DirectDrawSurface7 'This holds our bitmap
Dim primary As DirectDrawSurface7 'This surface represents the screen
Dim backbuffer As DirectDrawSurface7 'this describes the primary surface
Dim ddsd1 As DDSURFACEDESC2 'this describes the primary surface
Dim ddsd2 As DDSURFACEDESC2 'this describes the bitmap that we load
Dim ddsd3 As DDSURFACEDESC2 'this describes the size of the screen
Dim brunning As Boolean 'this is another flag that states whether or not
        'the main game loop is running.
Dim CurModeActiveStatus As Boolean 'This checks that we still have the
        'correct display mode
Dim bRestore As Boolean 'If we don't have the correct display mode then
        'this flag states that we need to restore the display mode


Sub Init()
    On Local Error GoTo errOut 'If there is an error we end the program.
    
    Set dd = dx.DirectDrawCreate("") 'the ("") means that we want the default driver
    Me.Show 'maximises the form and makes sure it's visible
    
    'The first line links the DirectDraw object to our form, It also sets the parameters
    'that are to be used - the important ones being DDSCL_FULLSCREEN and DDCSL_EXCLUSIVE. Making it
    'exclusive is important, it means that while our application is running nothing else can
    'use DirectDraw, and it makes windows give us more time/attention
    Call dd.SetCooperativeLevel(Me.hWnd, DDSCL_FULLSCREEN Or DDSCL_ALLOWMODEX Or DDSCL_EXCLUSIVE)
    'This is where we actually see a change. It states that we want a display mode
    'of 640x480 with 16 bit colour (65526 colours). the fourth argument ("0") is the
    'refresh rate. leave this to 0 and DirectX will sort out the best refresh rate. It is advised
    'that you don't mess about with this variable. the fifth variable is only used when you
    'want to use the more advanced resolutions (usually the lower, older ones)...
    Call dd.SetDisplayMode(640, 480, 16, 0, DDSDM_DEFAULT)
    
        
    'get the screen surface and create a back buffer too
    ddsd1.lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
    ddsd1.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_FLIP Or DDSCAPS_COMPLEX
    ddsd1.lBackBufferCount = 1
    Set primary = dd.CreateSurface(ddsd1)
    
    'Get the backbuffer
    Dim caps As DDSCAPS2
    caps.lCaps = DDSCAPS_BACKBUFFER
    Set backbuffer = primary.GetAttachedSurface(caps)
    backbuffer.GetSurfaceDesc ddsd3
               
    ' init the surfaces
    InitSurfaces
                                                  
    'This is the main loop. It only runs whilst brunning=true
    binit = True
    brunning = True
    Do While brunning
        blt
        DoEvents 'you MUST have a doevents in the loop, otherwise you'll overflow the
        'system (which is bad). All your application does is keep sending messages to DirectX
        'and windows, if you dont give them time to complete the operation they'll crash.
        'adding doevents allows windows to finish doing things that its doing.
    Loop

errOut: 'If there is an error we want to close the program down straight away.
    EndIt
End Sub

Sub InitSurfaces()
    'This procedure may look small, but when you make a program this procedure could
    'take a good 60-120 seconds to process, and run into 1000's of lines of code.

    Set Mainsurf = Nothing 'Although the first time we call this procedure this
    'variable will be empty, it must be cleared. As you'll see in the blt procedure
    'the program may try and re-load the surfaces, at which point the "mainsurf" object
    'will have some information in it. If we try and recreate a surface that already has
    'information in it DirectDraw will crash, because of this we must clear the buffer first.
    
    'load the bitmap into a surface - backdrop.bmp
    ddsd2.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH 'default flags
    ddsd2.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN 'An offscreenplain means that
    'the user never actually gets to see the surface - it is just an are in memory.
    ddsd2.lWidth = ddsd3.lWidth 'the ddsd3 structure already holds the size
    'of the screen. We could replace it with 640 and 480 - it would have the same effect
    ddsd2.lHeight = ddsd3.lHeight
    'this is where the surface is created. You use the DDraw object to create a
    'surface from the specified file name using the above description.
    Set Mainsurf = dd.CreateSurfaceFromFile(App.Path & "\backdrop.bmp", ddsd2)
    
End Sub


Sub blt()
    'again, this procedure looks fairly simple - it is!
    'You should try and keep this procedure as short as possible, and as fast as possible
    On Local Error GoTo errOut 'If there is an error don't do anything - just skip
    'the procedure
    If binit = False Then Exit Sub 'If we haven't initiaised then don't try anything
    'DirectDraw related.
    
    Dim ddrval As Long 'Every drawing procedure returns a value, so we must have a
    'variable to hold it. From this value we can check for errors.
    
    Dim rBack As RECT 'a RECT is the rectangle that i've mentioned.
   
    ' this will keep us from trying to blt in case we lose the surfaces (alt-tab)
    bRestore = False
    Do Until ExModeActive
        DoEvents
        bRestore = True
    Loop
    
    ' if we lost and got back the surfaces, then restore them
    DoEvents
    If bRestore Then
        bRestore = False
        dd.RestoreAllSurfaces 'this just re-allocates memory back to us. we must
        'still reload all the surfaces.
        InitSurfaces ' must init the surfaces again if they we're lost
    End If
    
    'get the area of the screen where our window is
    
    'this sets the rectangle to be the size of the screen.
    rBack.Bottom = ddsd3.lHeight
    rBack.Right = ddsd3.lWidth

    'blt to the backbuffer from our  surface to
    'the screen surface such that our bitmap
    'appears over the window
    'This Blits to the screen starting from 0,0 on the screen. the DDBLTFAST_WAIT
    'flag tells Directdraw to wait if the blitter is busy at the time of the call.
    ddrval = backbuffer.BltFast(0, 0, Mainsurf, rBack, DDBLTFAST_WAIT)
   
    'flip the back buffer to the screen
    primary.Flip Nothing, DDFLIP_WAIT
    'At this point we have completed one cycle, and we can now see something on screen

errOut:
'Skip everything if there is an error. Don't stick a message box in here - because
'you're likely to be running the program at 100's of frames per second, in just one second the
'program will try and generate 100 message boxes...
End Sub

Sub EndIt()
    'This procedure is called at the end of the loop, or whenever there is an error.
    'Although you can get away without these few lines it is a good idea to keep them
    'as you can get unpredictable results if you leave windows to "clear-up" after you.
    
    'This line restores you back to your default (windows) resolution.
    Call dd.RestoreDisplayMode
    'This tells windows/directX that we no longer want exclusive access
    'to the graphics features/directdraw
    Call dd.SetCooperativeLevel(Me.hWnd, DDSCL_NORMAL)
    'Stop the program:
    End
End Sub

Private Sub Form_Click()
    'Clicking the form will result in the program closing down.
    'because the form is maximised (and therefore covers the whole screen)
    'where you click is not important.
    EndIt
End Sub

Private Sub Form_Load()
    'Starts the whole program.
    Init
End Sub

Private Sub Form_Paint()
    'If windows sends a "paint" message translate this into a call
    'to DirectDraw.
    blt
End Sub

Function ExModeActive() As Boolean
    'This is used to test if we're in the correct resolution.
    Dim TestCoopRes As Long
    
    TestCoopRes = dd.TestCooperativeLevel
    
    If (TestCoopRes = DD_OK) Then
        ExModeActive = True
    Else
        ExModeActive = False
    End If
End Function
